



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AAC音频格式详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AAC音频格式详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 05:41:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>关于AAC音频格式基本情况，可参考维基百科<a href="http://en.wikipedia.org/wiki/Advanced_Audio_Coding" rel="external nofollow noreferrer">http://en.wikipedia.org/wiki/Advanced_Audio_Coding</a></p>
<p><strong>AAC音频格式分析</strong></p>
<p>AAC音频格式有ADIF和ADTS：</p>
<p><strong>ADIF：</strong>Audio Data Interchange Format 音频数据交换格式。这种格式的特征是可以确定的找到这个音频数据的开始，不需进行在音频数据流中间开始的解码，即它的解码必须在明确定义的开始处进行。故这种格式常用在磁盘文件中。</p>
<p><strong>ADTS</strong>：Audio Data Transport Stream 音频数据传输流。这种格式的特征是它是一个有同步字的比特流，解码可以在这个流中任何位置开始。它的特征类似于mp3数据流格式。</p>
<p>简单说，ADTS可以在任意帧解码，也就是说它每一帧都有头信息。ADIF只有一个统一的头，所以必须得到所有的数据后解码。且这两种的header的格式也是不同的，目前一般编码后的和抽取出的都是ADTS格式的音频流。</p>
<p>语音系统对实时性要求较高，基本是这样一个流程，采集音频数据，本地编码，数据上传，服务器处理，数据下发，本地解码</p>
<p>ADTS是帧序列，本身具备流特征，在音频流的传输与处理方面更加合适。</p>
<p><strong>ADTS帧结构：</strong></p>
<table>
<tbody>
<tr>
<td>
<p>header</p>
</td>
<td>
<p>body</p>
</td>
</tr>
</tbody>
</table>
<p><strong>ADTS帧首部结构：</strong></p>
<table>
<tbody>
<tr>
<td><strong>序号</strong></td>
<td><strong>域</strong></td>
<td><strong>长度（bits）</strong></td>
<td><strong>说明</strong></td>
</tr>
<tr>
<td>1</td>
<td>Syncword</td>
<td>12</td>
<td>all bits&nbsp;<strong>must</strong>&nbsp;be 1</td>
</tr>
<tr>
<td>2</td>
<td>MPEG version</td>
<td>1</td>
<td>0 for MPEG-4, 1 for MPEG-2</td>
</tr>
<tr>
<td>3</td>
<td>Layer</td>
<td>2</td>
<td>always 0</td>
</tr>
<tr>
<td>4</td>
<td>Protection Absent</td>
<td>1</td>
<td>et to 1 if there is no CRC and 0 if there is CRC</td>
</tr>
<tr>
<td>5</td>
<td>Profile</td>
<td>2</td>
<td>the&nbsp;<a href="http://wiki.multimedia.cx/index.php?title=MPEG-4_Audio#Audio_Object_Types" rel="external nofollow noreferrer">MPEG-4 Audio Object Type</a>&nbsp;minus 1</td>
</tr>
<tr>
<td>6</td>
<td>MPEG-4 Sampling Frequency Index</td>
<td>4</td>
<td><a href="http://wiki.multimedia.cx/index.php?title=MPEG-4_Audio#Sampling_Frequencies" rel="external nofollow noreferrer">MPEG-4 Sampling Frequency Index</a>&nbsp;(15 is forbidden)</td>
</tr>
<tr>
<td>7</td>
<td>Private Stream</td>
<td>1</td>
<td>set to 0 when encoding, ignore when decoding</td>
</tr>
<tr>
<td>8</td>
<td>MPEG-4 Channel Configuration</td>
<td>3</td>
<td><a href="http://wiki.multimedia.cx/index.php?title=MPEG-4_Audio#Channel_Configurations" rel="external nofollow noreferrer">MPEG-4 Channel Configuration</a>&nbsp;(in the case of 0, the channel configuration is sent via an inband PCE)</td>
</tr>
<tr>
<td>9</td>
<td>Originality</td>
<td>1</td>
<td>set to 0 when encoding, ignore when decoding</td>
</tr>
<tr>
<td>10</td>
<td>Home</td>
<td>1</td>
<td>set to 0 when encoding, ignore when decoding</td>
</tr>
<tr>
<td>11</td>
<td>Copyrighted Stream</td>
<td>1</td>
<td>set to 0 when encoding, ignore when decoding</td>
</tr>
<tr>
<td>12</td>
<td>Copyrighted Start</td>
<td>1</td>
<td>set to 0 when encoding, ignore when decoding</td>
</tr>
<tr>
<td>13</td>
<td>Frame Length</td>
<td>13</td>
<td>this value must include 7 or 9 bytes of header length: FrameLength = (ProtectionAbsent == 1 ? 7 : 9) + size(AACFrame)</td>
</tr>
<tr>
<td>14</td>
<td>Buffer Fullness</td>
<td>11</td>
<td>buffer fullness</td>
</tr>
<tr>
<td>15</td>
<td>Number of AAC Frames</td>
<td>2</td>
<td>number of AAC frames (RDBs) in ADTS frame&nbsp;<strong>minus 1</strong>, for maximum compatibility always use 1 AAC frame per ADTS frame</td>
</tr>
<tr>
<td>16</td>
<td>CRC</td>
<td>16</td>
<td>CRC if&nbsp;<em>protection absent</em>&nbsp;is 0</td>
</tr>
</tbody>
</table>
<p><strong>AAC解码</strong></p>
<p>在解码方面，使用了开源的FAAD，<a href="http://www.audiocoding.com/faad2.html" rel="external nofollow noreferrer">http://www.audiocoding.com/faad2.html</a></p>
<p>sdk解压缩后，docs目录有详细的api说明文档，主要用到的有以下几个：</p>
<pre class="prettyprint linenums">NeAACDecHandle NEAACAPI NeAACDecOpen(void);
</pre>
<pre class="prettyprint linenums">创建解码环境并返回一个句柄
</pre>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">void NEAACAPI NeAACDecClose(NeAACDecHandle hDecoder);
</pre>
<pre class="prettyprint linenums">关闭解码环境
</pre>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">NeAACDecConfigurationPtr NEAACAPI NeAACDecGetCurrentConfiguration(NeAACDecHandle hDecoder);
</pre>
<pre class="prettyprint linenums">获取当前解码器库的配置
</pre>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">unsigned char NEAACAPI NeAACDecSetConfiguration(NeAACDecHandle hDecoder, NeAACDecConfigurationPtr config);
</pre>
<pre class="prettyprint linenums">为解码器库设置一个配置结构
</pre>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">long NEAACAPI NeAACDecInit(NeAACDecHandle hDecoder, unsigned char *buffer, unsigned long buffer_size, unsigned long *samplerate, unsigned char *channels);
</pre>
<pre class="prettyprint linenums">初始化解码器库
</pre>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">void* NEAACAPI NeAACDecDecode(NeAACDecHandle hDecoder, NeAACDecFrameInfo *hInfo, unsigned char *buffer, unsigned long buffer_size);
</pre>
<pre class="prettyprint linenums">解码AAC数据</pre>
<p>对以上api做了简单封装，写了一个解码类，涵盖了FAAD库的基本用法，感兴趣的朋友可以看看</p>
<p>MyAACDecoder.h：</p>
<div>
<pre class="prettyprint linenums">/**</pre>
<pre class="prettyprint linenums"> *</pre>
<pre class="prettyprint linenums"> * filename: MyAACDecoder.h</pre>
<pre class="prettyprint linenums"> * summary: convert aac to wave</pre>
<pre class="prettyprint linenums"> * author: caosiyang </pre>
<pre class="prettyprint linenums"> * email: csy3228@gmail.com</pre>
<pre class="prettyprint linenums"> *</pre>
<pre class="prettyprint linenums"> */</pre>
<pre class="prettyprint linenums">#ifndef __MYAACDECODER_H__</pre>
<pre class="prettyprint linenums">#define __MYAACDECODER_H__</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">#include "Buffer.h"</pre>
<pre class="prettyprint linenums">#include "mytools.h"</pre>
<pre class="prettyprint linenums">#include "WaveFormat.h"</pre>
<pre class="prettyprint linenums">#include "faad.h"</pre>
<pre class="prettyprint linenums">#include &lt;iostream&gt;</pre>
<pre class="prettyprint linenums">using namespace std;</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">class MyAACDecoder {</pre>
<pre class="prettyprint linenums">public:</pre>
<pre class="prettyprint linenums">    MyAACDecoder();</pre>
<pre class="prettyprint linenums">    ~MyAACDecoder();</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    int32_t Decode(char *aacbuf, uint32_t aacbuflen);</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    const char* WavBodyData() const {</pre>
<pre class="prettyprint linenums">        return _mybuffer.Data();</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    uint32_t WavBodyLength() const {</pre>
<pre class="prettyprint linenums">        return _mybuffer.Length();</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    const char* WavHeaderData() const {</pre>
<pre class="prettyprint linenums">        return _wave_format.getHeaderData();</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    uint32_t WavHeaderLength() const {</pre>
<pre class="prettyprint linenums">        return _wave_format.getHeaderLength();</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">private:</pre>
<pre class="prettyprint linenums">    MyAACDecoder(const MyAACDecoder &amp;dec);</pre>
<pre class="prettyprint linenums">    MyAACDecoder&amp; operator=(const MyAACDecoder &amp;rhs);</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //init AAC decoder</pre>
<pre class="prettyprint linenums">    int32_t _init_aac_decoder(char *aacbuf, int32_t aacbuflen);</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //destroy aac decoder</pre>
<pre class="prettyprint linenums">    void _destroy_aac_decoder();</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //parse AAC ADTS header, get frame length</pre>
<pre class="prettyprint linenums">    uint32_t _get_frame_length(const char *aac_header) const;</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //AAC decoder properties</pre>
<pre class="prettyprint linenums">    NeAACDecHandle _handle;</pre>
<pre class="prettyprint linenums">    unsigned long _samplerate;</pre>
<pre class="prettyprint linenums">    unsigned char _channel;</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    Buffer _mybuffer;</pre>
<pre class="prettyprint linenums">    WaveFormat _wave_format;</pre>
<pre class="prettyprint linenums">};</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">#endif /*__MYAACDECODER_H__*/</pre>
</div>
<p>MyAACDecoder.cpp：</p>
<div>
<pre class="prettyprint linenums">#include "MyAACDecoder.h"</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">MyAACDecoder::MyAACDecoder(): _handle(NULL), _samplerate(44100), _channel(2), _mybuffer(4096, 4096) {</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">MyAACDecoder::~MyAACDecoder() {</pre>
<pre class="prettyprint linenums">    _destroy_aac_decoder();</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">int32_t MyAACDecoder::Decode(char *aacbuf, uint32_t aacbuflen) {</pre>
<pre class="prettyprint linenums">    int32_t res = 0;</pre>
<pre class="prettyprint linenums">    if (!_handle) {</pre>
<pre class="prettyprint linenums">        if (_init_aac_decoder(aacbuf, aacbuflen) != 0) {</pre>
<pre class="prettyprint linenums">            ERR1(":::: init aac decoder failed ::::");</pre>
<pre class="prettyprint linenums">            return -1;</pre>
<pre class="prettyprint linenums">        }</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //clean _mybuffer</pre>
<pre class="prettyprint linenums">    _mybuffer.Clean();</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    uint32_t donelen = 0;</pre>
<pre class="prettyprint linenums">    uint32_t wav_data_len = 0;</pre>
<pre class="prettyprint linenums">    while (donelen &lt; aacbuflen) {</pre>
<pre class="prettyprint linenums">        uint32_t framelen = _get_frame_length(aacbuf + donelen);</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">        if (donelen + framelen &gt; aacbuflen) {</pre>
<pre class="prettyprint linenums">            break;</pre>
<pre class="prettyprint linenums">        }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">        //decode</pre>
<pre class="prettyprint linenums">        NeAACDecFrameInfo info;</pre>
<pre class="prettyprint linenums">        void *buf = NeAACDecDecode(_handle, &amp;info, (unsigned char*)aacbuf + donelen, framelen);</pre>
<pre class="prettyprint linenums">        if (buf &amp;&amp; info.error == 0) {</pre>
<pre class="prettyprint linenums">            if (info.samplerate == 44100) {</pre>
<pre class="prettyprint linenums">                //44100Hz</pre>
<pre class="prettyprint linenums">                //src: 2048 samples, 4096 bytes</pre>
<pre class="prettyprint linenums">                //dst: 2048 samples, 4096 bytes</pre>
<pre class="prettyprint linenums">                uint32_t tmplen = info.samples * 16 / 8;</pre>
<pre class="prettyprint linenums">                _mybuffer.Fill((const char*)buf, tmplen);</pre>
<pre class="prettyprint linenums">                wav_data_len += tmplen;</pre>
<pre class="prettyprint linenums">            } else if (info.samplerate == 22050) {</pre>
<pre class="prettyprint linenums">                //22050Hz</pre>
<pre class="prettyprint linenums">                //src: 1024 samples, 2048 bytes</pre>
<pre class="prettyprint linenums">                //dst: 2048 samples, 4096 bytes</pre>
<pre class="prettyprint linenums">                short *ori = (short*)buf;</pre>
<pre class="prettyprint linenums">                short tmpbuf[info.samples * 2];</pre>
<pre class="prettyprint linenums">                uint32_t tmplen = info.samples * 16 / 8 * 2;</pre>
<pre class="prettyprint linenums">                for (int32_t i = 0, j = 0; i &lt; info.samples; i += 2) {</pre>
<pre class="prettyprint linenums">                    tmpbuf[j++] = ori[i];</pre>
<pre class="prettyprint linenums">                    tmpbuf[j++] = ori[i + 1];</pre>
<pre class="prettyprint linenums">                    tmpbuf[j++] = ori[i];</pre>
<pre class="prettyprint linenums">                    tmpbuf[j++] = ori[i + 1];</pre>
<pre class="prettyprint linenums">                }</pre>
<pre class="prettyprint linenums">                _mybuffer.Fill((const char*)tmpbuf, tmplen);</pre>
<pre class="prettyprint linenums">                wav_data_len += tmplen;</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">        } else {</pre>
<pre class="prettyprint linenums">            ERR1("NeAACDecDecode() failed");</pre>
<pre class="prettyprint linenums">        }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">        donelen += framelen;</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    //generate Wave header</pre>
<pre class="prettyprint linenums">    _wave_format.setSampleRate(_samplerate);</pre>
<pre class="prettyprint linenums">    _wave_format.setChannel(_channel);</pre>
<pre class="prettyprint linenums">    _wave_format.setSampleBit(16);</pre>
<pre class="prettyprint linenums">    _wave_format.setBandWidth(_samplerate * 16 * _channel / 8);</pre>
<pre class="prettyprint linenums">    _wave_format.setDataLength(wav_data_len);</pre>
<pre class="prettyprint linenums">    _wave_format.setTotalLength(wav_data_len + 44);</pre>
<pre class="prettyprint linenums">    _wave_format.GenerateHeader();</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    return 0;</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">uint32_t MyAACDecoder::_get_frame_length(const char *aac_header) const {</pre>
<pre class="prettyprint linenums">    uint32_t len = *(uint32_t *)(aac_header + 3);</pre>
<pre class="prettyprint linenums">    len = ntohl(len); //Little Endian</pre>
<pre class="prettyprint linenums">    len = len &lt;&lt; 6;</pre>
<pre class="prettyprint linenums">    len = len &gt;&gt; 19;</pre>
<pre class="prettyprint linenums">    return len;</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">int32_t MyAACDecoder::_init_aac_decoder(char* aacbuf, int32_t aacbuflen) {</pre>
<pre class="prettyprint linenums">    unsigned long cap = NeAACDecGetCapabilities();</pre>
<pre class="prettyprint linenums">    _handle = NeAACDecOpen();</pre>
<pre class="prettyprint linenums">    if (!_handle) {</pre>
<pre class="prettyprint linenums">        ERR1("NeAACDecOpen() failed");</pre>
<pre class="prettyprint linenums">        _destroy_aac_decoder();</pre>
<pre class="prettyprint linenums">        return -1;</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    NeAACDecConfigurationPtr conf = NeAACDecGetCurrentConfiguration(_handle);</pre>
<pre class="prettyprint linenums">    if (!conf) {</pre>
<pre class="prettyprint linenums">        ERR1("NeAACDecGetCurrentConfiguration() failed");</pre>
<pre class="prettyprint linenums">        _destroy_aac_decoder();</pre>
<pre class="prettyprint linenums">        return -1;</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums">    NeAACDecSetConfiguration(_handle, conf);</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    long res = NeAACDecInit(_handle, (unsigned char *)aacbuf, aacbuflen, &amp;_samplerate, &amp;_channel);</pre>
<pre class="prettyprint linenums">    if (res &lt; 0) {</pre>
<pre class="prettyprint linenums">        ERR1("NeAACDecInit() failed");</pre>
<pre class="prettyprint linenums">        _destroy_aac_decoder();</pre>
<pre class="prettyprint linenums">        return -1;</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums">    //fprintf(stdout, "SampleRate = %d\n", _samplerate);</pre>
<pre class="prettyprint linenums">    //fprintf(stdout, "Channel    = %d\n", _channel);</pre>
<pre class="prettyprint linenums">    //fprintf(stdout, ":::: init aac decoder done ::::\n");</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">    return 0;</pre>
<pre class="prettyprint linenums">}</pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums"> </pre>
<pre class="prettyprint linenums">void MyAACDecoder::_destroy_aac_decoder() {</pre>
<pre class="prettyprint linenums">    if (_handle) {</pre>
<pre class="prettyprint linenums">        NeAACDecClose(_handle);</pre>
<pre class="prettyprint linenums">        _handle = NULL;</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums">}</pre>
</div>
<h2>1.ADTS是个啥</h2>
<p>ADTS全称是(Audio Data Transport Stream)，是AAC的一种十分常见的传输格式。</p>
<p>记得第一次做demux的时候，把AAC音频的ES流从FLV封装格式中抽出来送给硬件解码器时，不能播;保存到本地用pc的播放器播时，我靠也不能播。当时崩溃了，后来通过查找资料才知道。一般的AAC解码器都需要把AAC的ES流打包成ADTS的格式，一般是在AAC ES流前添加7个字节的ADTS header。也就是说你可以吧ADTS这个头看作是AAC的frameheader。</p>
<table>
<tbody>
<tr>
<td colspan="7">
<div>ADTS AAC</div>
</td>
</tr>
<tr>
<td>ADTS_header</td>
<td>AAC ES</td>
<td>ADTS_header</td>
<td>AAC ES</td>
<td>
<div>...</div>
</td>
<td>ADTS_header</td>
<td>AAC ES</td>
</tr>
</tbody>
</table>

<h2>2.ADTS内容及结构</h2>
<p>ADTS 头中相对有用的信息<strong>&nbsp;采样率、声道数、帧长度</strong>。想想也是，我要是解码器的话，你给我一堆得AAC音频ES流我也解不出来。每一个带ADTS头信息的AAC流会清晰的告送解码器他需要的这些信息。</p>
<p>一般情况下ADTS的头信息都是7个字节，分为2部分：</p>
<p><strong>adts_fixed_header();</strong></p>
<p><strong>adts_variable_header();</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="http://my.csdn.net/uploads/201203/31/1333164211_8586.jpg" /><br /></strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>syncword&nbsp;</strong>：同步头 总是0xFFF, all bits must be 1，代表着一个ADTS帧的开始</p>
<p><strong>ID</strong>：MPEG Version: 0 for MPEG-4, 1 for MPEG-2</p>
<p><strong>Layer</strong>：always: '00'</p>
<p><strong>profile</strong>：表示使用哪个级别的AAC，有些芯片只支持AAC LC 。在MPEG-2 AAC中定义了3种：</p>
<p><img referrerpolicy="no-referrer"src="http://my.csdn.net/uploads/201203/31/1333165759_1644.jpg" /></p>
<p><strong>sampling_frequency_index</strong>：表示使用的采样率下标，通过这个下标在&nbsp;<strong>Sampling Frequencies[ ]</strong>数组中查找得知采样率的值。</p>
<p>There are 13 supported frequencies:</p>
<ul><li>0: 96000 Hz</li>
<li>1: 88200 Hz</li>
<li>2: 64000 Hz</li>
<li>3: 48000 Hz</li>
<li>4: 44100 Hz</li>
<li>5: 32000 Hz</li>
<li>6: 24000 Hz</li>
<li>7: 22050 Hz</li>
<li>8: 16000 Hz</li>
<li>9: 12000 Hz</li>
<li>10: 11025 Hz</li>
<li>11: 8000 Hz</li>
<li>12: 7350 Hz</li>
<li>13: Reserved</li>
<li>14: Reserved</li>
<li>15: frequency is written explictly</li></ul>
<p>channel_configuration:&nbsp;表示声道数</p>
<ul><li>0: Defined in AOT Specifc Config</li>
<li>1: 1 channel: front-center</li>
<li>2: 2 channels: front-left, front-right</li>
<li>3: 3 channels: front-center, front-left, front-right</li>
<li>4: 4 channels: front-center, front-left, front-right, back-center</li>
<li>5: 5 channels: front-center, front-left, front-right, back-left, back-right</li>
<li>6: 6 channels: front-center, front-left, front-right, back-left, back-right, LFE-channel</li>
<li>7: 8 channels: front-center, front-left, front-right, side-left, side-right, back-left, back-right, LFE-channel</li>
<li>8-15: Reserved</li></ul>
<p><img referrerpolicy="no-referrer"src="http://my.csdn.net/uploads/201203/31/1333171714_8159.jpg" /></p>
<p><strong>frame_length</strong>&nbsp;: 一个ADTS帧的长度包括ADTS头和AAC原始流.</p>
<p><strong>adts_buffer_fullness：</strong>0x7FF 说明是码率可变的码流</p>
<h2>3.将AAC打包成ADTS格式</h2>
<p>如果是通过嵌入式高清解码芯片做产品的话，一般情况的解码工作都是由硬件来完成的。所以大部分的工作是把AAC原始流打包成ADTS的格式，然后丢给硬件就行了。</p>
<p>通过对ADTS格式的了解，很容易就能把AAC打包成ADTS。我们只需得到封装格式里面关于音频采样率、声道数、元数据长度、aac格式类型等信息。然后在每个AAC原始流前面加上个ADTS头就OK了。</p>
<p>贴上ffmpeg中添加ADTS头的代码，就可以很清晰的了解ADTS头的结构：</p>
<div>
<ol><li>int&nbsp;ff_adts_write_frame_header(ADTSContext&nbsp;*ctx,</li>
<li>uint8_t&nbsp;*buf,&nbsp;int&nbsp;size,&nbsp;int&nbsp;pce_size)</li>
<li>{</li>
<li>PutBitContext&nbsp;pb;</li>
<li>init_put_bits(&amp;pb,&nbsp;buf,&nbsp;ADTS_HEADER_SIZE);</li>
<li>/*&nbsp;adts_fixed_header&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;12,&nbsp;0xfff);&nbsp;&nbsp;&nbsp;/*&nbsp;syncword&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;ID&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;2,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;layer&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;1);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;protection_absent&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;2,&nbsp;ctx-&gt;objecttype);&nbsp;/*&nbsp;profile_objecttype&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;4,&nbsp;ctx-&gt;sample_rate_index);</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;private_bit&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;3,&nbsp;ctx-&gt;channel_conf);&nbsp;/*&nbsp;channel_configuration&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;original_copy&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;home&nbsp;*/</li>
<li>/*&nbsp;adts_variable_header&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;copyright_identification_bit&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;1,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;copyright_identification_start&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;13,&nbsp;ADTS_HEADER_SIZE&nbsp;+&nbsp;size&nbsp;+&nbsp;pce_size);&nbsp;/*&nbsp;aac_frame_length&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;11,&nbsp;0x7ff);&nbsp;&nbsp;&nbsp;/*&nbsp;adts_buffer_fullness&nbsp;*/</li>
<li>put_bits(&amp;pb,&nbsp;2,&nbsp;0);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/*&nbsp;number_of_raw_data_blocks_in_frame&nbsp;*/</li>
<li>flush_put_bits(&amp;pb);</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
</div>
<div>&nbsp;</div>
<div>
<dl>
<dt>顶</dt>
<dd>0</dd>
</dl>
<dl>
<dt>踩</dt>
</dl>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8okrw59.html">dataTables获取当前行json格式数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdwjj79.html">&lbrack;译&rsqb;MVC网站教程（四）：MVC4网站中集成jqGrid表格插件（系列完结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mw0x0q.html">urllib2抓取HTML存入Excel</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3nmkq.html">C&num;窗体布局方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnz45gq.html">链式编程中的next&lpar;&rpar;和end&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39037339.html">yum 部署nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1r31q.html">linux centos安装编译phantomjs 2&period;0的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdryyr8.html">C&plus;&plus;：虚函数的引入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04pk0q.html">从字符串总分离文件路径、命名、扩展名，Substring&lpar;&rpar;&comma;LastIndexOf&lpar;&rpar;的使用；替换某一类字符串，Replace（）的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvl1zxq.html">hdu 4541 Ten Googol</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ljxe8.html">JavaScript&lpar;第二十五天&rpar;【事件绑定及深入】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp4zxxq.html">Redis配置信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjo7pg8.html">针对缓存在Redis中的聊天消息的持久化方案分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wwv5zq.html">Javascript高级编程学习笔记（52）&mdash;&mdash; DOM2和DOM3（4）元素大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwjrov9.html">利用fpm制作rpm包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmkzr9.html">qtp 自动货测试桌面程序-笔记（使用函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyj2nx9.html">tempalte模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkmo5q.html">&lbrack;BZOJ1899&rsqb;&lbrack;ZJOI2004&rsqb;Lunch 午餐 &lpar;DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwve17y8.html">python 全栈开发，Day49&lpar;超链接导航栏案例&comma;background&comma;定位&comma;z-index&comma;iconfont使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjy7779.html">php ActiveMQ的安装与使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o4l6g5q.html">《&lbrack;C&num;&rsqb; int与System&period;Int32有什么区别》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve34vo9.html">个人作业2&mdash;&mdash;APP案例分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv0zjgq.html">WinForm中DataGridView的全选与取消全选</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmd5309.html">KEIL C51 printf格式化输出特殊用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zke0wx8.html">单片机FLASH与RAM、ROM的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kyrxvq.html">利用ceye中的dns来获取数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv0p0dq.html">python读取文件解码失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjrgz68.html">Gitlab的安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjrorr8.html">QVariant相当于一个包含大多数Qt数据类型的联合体（源码解读）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlzdz39.html">【uoj&num;143】&lbrack;UER &num;5&rsqb;万圣节的数列  构造</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
